export function trivialComparator(left: any, right: any): 0 | 1 | -1;
export function getPassStyleCover(passStyle: PassStyle): RankCover;
export function makeComparatorKit(compareRemotables?: PartialCompare | undefined): RankComparatorKit;
export function comparatorMirrorImage(comparator: RankCompare): RankCompare | undefined;
export function isRankSorted(passables: Passable[], compare: RankCompare): boolean;
export function assertRankSorted(sorted: Passable[], compare: RankCompare): true;
export function sortByRank<T extends Passable>(passables: Iterable<T>, compare: RankCompare): T[];
export function getIndexCover(sorted: Passable[], compare: RankCompare, [leftKey, rightKey]: RankCover): IndexCover;
/** @type {RankCover} */
export const FullRankCover: RankCover;
export function coveredEntries(sorted: Passable[], [leftIndex, rightIndex]: IndexCover): Iterable<[number, Passable]>;
export function unionRankCovers(compare: RankCompare, covers: RankCover[]): RankCover;
export function intersectRankCovers(compare: RankCompare, covers: RankCover[]): RankCover;
export const compareRank: RankCompare;
export const compareAntiRank: RankCompare;
export function makeFullOrderComparatorKit(longLived?: boolean | undefined): FullComparatorKit;
export type RankComparatorKit = {
    comparator: RankCompare;
    antiComparator: RankCompare;
};
export type FullComparatorKit = {
    comparator: FullCompare;
    antiComparator: FullCompare;
};
export type IndexCover = [number, number];
export type PassStyleRanksRecord = Record<PassStyle, {
    index: number;
    cover: RankCover;
}>;
import type { PassStyle } from '@endo/pass-style';
import type { RankCover } from './types.js';
import type { PartialCompare } from './types.js';
import type { RankCompare } from './types.js';
import type { Passable } from '@endo/pass-style';
import type { FullCompare } from './types.js';
//# sourceMappingURL=rankOrder.d.ts.map